#ifndef AVEPLANE_H
#define AVEPLANE_H 

#include <stdio.h>
#include "PointSet.h"
//#include "ImplicitOctTree.h"
#include "LocalApprox.h"

class ImplicitOctCell;

class AvePlane: public LocalApprox{

public:
	float _c0, _cx, _cy, _cz;

	AvePlane(PointSet* ps, float R, ImplicitOctCell *cell);

	float value(float x, float y, float z){
		return _c0 + _cx*x + _cy*y + _cz*z;
	}

	void gradient(float g[], float x, float y, float z){
		g[0] = _cx;
		g[1] = _cy;
		g[2] = _cz;
	}
};

#endif