#ifndef PLANE_H
#define PLANE_H 


#include <stdio.h>
#include "PointSet.h"
#include "LocalApprox.h"

#define OFF 0.01f

class ImplicitOctCell;

class Plane: public LocalApprox{

public:
	float _c0, _cx, _cy, _cz;

	Plane(PointSet* ps, float R, ImplicitOctCell *cell);

	float value(float x, float y, float z){
		return _c0 + _cx*x + _cy*y + _cz*z;
	}

	void gradient(float g[], float x, float y, float z){
		g[0] = _cx;
		g[1] = _cy;
		g[2] = _cz;
	}
};

#endif